#!/usr/bin/python
#  Copyright (c) 1999-2017, Parallels International GmbH. All rights reserved.
#
#  This file is part of OpenVZ. OpenVZ is free software; you can redistribute
#  it and/or modify it under the terms of the GNU General Public License as
#  published by the Free Software Foundation; either version 2 of the License,
#  or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#  02110-1301, USA.
#
#  Our contact details: Parallels International GmbH, Vordergasse 59, 8200
#  Schaffhausen, Switzerland.

from unidecode import unidecode
import codecs
import shlex
import sys

class More(object):
    '''
      Class to print long text with "more"-like functionality
    '''
    def __init__(self):
        # Rows in terminal
        rows = 40
        try:
            rows_ = int(subprocess.check_output(shlex.split('tput lines')))
            if rows_:
                rows  = rows_
        except:
            pass
        self.num_lines = rows-1

    def __ror__(self, other):
        '''
          Pipe operator
        '''  
        s = str(other).split("\n")
        for i in xrange(0, len(s), self.num_lines):
            print "\n".join(s[i:i+self.num_lines])
            raw_input("Press <Enter> for more")

def check_args():
    if len(sys.argv) != 2:
        print "Usage: " + sys.argv[0] + " <EULA file name>"
        sys.exit(1)

def get_eula_text():
    return unidecode(
        codecs
            .open(EULA_FILE, 'r', 'utf-8')
            .read()
    ).encode('ascii')

if __name__ == '__main__':
    check_args()
    EULA_FILE = sys.argv[1]
    eula_text = get_eula_text()

    more = More()
    eula_text | more
    accept = ''
    eula_accepted = False
    while not accept:
        accept = raw_input("Accept EULA? [y/n]")
    if accept and accept[0] in ['y', 'Y']:
        eula_accepted = True

    if not eula_accepted:
        sys.exit(1)
